;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Copyright (C) 2002 Robert P. Wolf ;;
;;        ALL RIGHTS RESERVED        ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


program studio #machine := "prolog.studio"


	[
		set_uap32_captions set_standard_captions set_edinburg_captions set_marseille_captions set_functional_captions
		auto_atoms scripted_atoms
		pr read readln
		write nl pp pt list
		cd file_writer import load consult batch file_reader reload
		CL cl addcl addcl0 DELCL OVERWRITE delcl delallcl overwrite let
		create_atom search_atom
		add sub mult div mod and or xor sum times less less_eq
		abs acos asin atan cos e exp ln log pi pow sin tan trunc
		is_atom is_integer is_double is_number is_var is_head is_text
		text_list text_term e32 query_stack object_counter
		exit command inner
		res not eq TRY ONE PROBE APPEND LENGTH REVERSE MAP WHILE FOR IF THEN ELSE
		CONSTANT VARIABLE ACCUMULATOR CLOSURE ARRAY closure call BLOCK ISALL isall
		crack wait
		rnd rnd_control
		start pause stop wt beat bar signal signal_beat signal_bar reset tempo division metrum
		set_colors OPEN_EDITOR open_editor close_editor
		screen_coordinates
		open_keyboard open_oscilloscope
		get_volume_serial_number security_check

		noteon noteoff computer-do-this define-this show

		income_midi keyoff keyon polyaftertouch control programchange aftertouch pitch
		sysex sysexch SYSEX SYSEXCH timingclock START CONTINUE STOP
		attack release cutoff resonance mono poly bank banklsb portaon portaoff portatime
		volume reverb chorus foot breath pan modulation holdon holdoff
		CONTROL ATTACK RELEASE CUTOFF RESONANCE PORTATIME
		VOLUME REVERB CHORUS FOOT BREATH PAN MODULATION
		nrpn rpn NRPN RPN hit
		midi_close midi_in_info midi_out_info midi_in_port midi_out_port midi_short_msg MIDI_SHORT_MSG midi_long_msg
	]

#machine sum := "sum"
#machine add := "add"
#machine sub := "sub"
#machine times := "times"
#machine mult := "mult"
#machine div := "div"
#machine mod := "mod"
#machine and := "and"
#machine or := "or"
#machine xor := "xor"

#machine abs := "abs"
#machine acos := "acos"
#machine asin := "asin"
#machine atan := "atan"
#machine cos := "cos"
#machine e := "e"
#machine exp := "exp"
#machine ln := "ln"
#machine log := "log"
#machine pi := "pi"
#machine pow := "pow"
#machine sin := "sin"
#machine tan := "tan"
#machine trunc := "trunc"

#machine is_atom := "is_atom"
#machine is_integer := "is_integer"
#machine is_double := "is_double"
#machine is_number := "is_number"
#machine is_var := "is_var"
#machine is_head := "is_head"
#machine is_text := "is_text"
#machine text_list := "text_list"
#machine text_term := "text_term"
#machine e32 := "e32"
#machine less := "less"
#machine less_eq := "less_eq"
#machine set_standard_captions := "set_standard_captions"
#machine set_uap32_captions := "set_uap32_captions"
#machine set_edinburg_captions := "set_edinburg_captions"
#machine set_marseille_captions := "set_marseille_captions"
#machine set_functional_captions := "set_functional_captions"
#machine auto_atoms := "auto_atoms"
#machine scripted_atoms := "scripted_atoms"
#machine pr := "pr"
#machine read := "read"
#machine readln := "readln"
#machine pp := "pp"
#machine pt := "pt"
#machine write := "write"
#machine nl := "nl"
#machine list := "list"
#machine CL := "CL"
#machine addcl := "addcl"
#machine addcl0 := "addcl0"
#machine DELCL := "delcl"
#machine OVERWRITE := "overwrite"
#machine create_atom := "create_atom"
#machine search_atom := "search_atom"
#machine query_stack := "query_stack"
#machine object_counter := "object_counter"
#machine crack := "crack"
#machine wait := "wait"
#machine rnd := "rnd"
#machine rnd_control := "rnd_control"

#machine cd := "cd"
#machine file_writer := "file_writer"
#machine file_reader := "file_reader"
#machine import := "import_loader"
#machine load := "load_loader"
#machine consult := "consult_loader"

#machine CONSTANT := "CONSTANT"
#machine VARIABLE := "VARIABLE"
#machine ACCUMULATOR := "ACCUMULATOR"
#machine CLOSURE := "CLOSURE"
#machine ARRAY := "ARRAY"

#machine start := "start"
#machine pause := "pause"
#machine stop := "stop"
#machine wt := "wt"
#machine beat := "beat"
#machine bar := "bar"
#machine signal := "signal"
#machine signal_beat := "signal_beat"
#machine signal_bar := "signal_bar"
#machine reset := "reset"
#machine tempo := "tempo"
#machine division := "tempo_division"
#machine metrum := "metrum"

#machine midi_in_info := "midi_in_info"
#machine midi_out_info := "midi_out_info"
#machine midi_in_port := "midi_in_port"
#machine midi_out_port := "midi_out_port"

#machine midi_short_msg := "midi_short_msg"
#machine MIDI_SHORT_MSG := "MIDI_SHORT_MSG"
#machine midi_long_msg := "midi_long_msg"
#machine sysex := "sysex"
#machine sysexch := "sysexch"
#machine SYSEX := "SYSEX"
#machine SYSEXCH := "SYSEXCH"

#machine set_colors := "set_colors"
#machine OPEN_EDITOR := "open_editor"
#machine close_editor := "close_editor"
#machine screen_coordinates := "screen_coordinates"

#machine get_volume_serial_number := "get_volume_serial_number"
#machine security_check := "security_check"

[[open_editor] [OPEN_EDITOR]]
[[open_editor *id] [OPEN_EDITOR *id]]
[[open_editor *x *y] [screen_coordinates *x *y] [OPEN_EDITOR]]
[[open_editor *id *x *y] [screen_coordinates *x *y] [OPEN_EDITOR *id]]
[[open_keyboard] [OPEN_EDITOR 1]]
[[open_keyboard *x *y] [screen_coordinates *x *y] [OPEN_EDITOR 1]]
[[open_oscilloscope] [OPEN_EDITOR 3]]
[[open_oscilloscope *x *y] [screen_coordinates *x *y] [OPEN_EDITOR 3]]


[[eq *x *x]]
[[not :*x] *x / fail]
[[not :*x]]
[[res :*x]:*x]
[[ONE :*o][res :*o]/]
[[TRY :*o]:*o]
[[TRY :*o]]
[[PROBE :*o][ONE :*o] fail]
[[PROBE :*o]]
[[APPEND [] *l *l]]
[[APPEND [*head : *tail] *l [*head : *new]]/
	[APPEND *tail *l *new]]
[[REVERSE *l1 *l2] [REVERSE *l1 [] *l2]]
[[REVERSE [] *x *x]]
[[REVERSE [*head : *tail] *l0 *list] [REVERSE *tail [*head : *l0] *list]]
[[LENGTH [] 0]]
[[LENGTH [*head : *tail] *length] [LENGTH *tail *l] [sum *l 1 *length]]
[[MAP [] [] []]]
[[MAP [[*x *y] : *xyt] [*x : *xt] [*y : *yt]] / [MAP *xyt *xt *yt]]
[[WHILE *condition : *call] [not not res : *condition] / [PROBE : *call] / [WHILE *condition : *call]]
[[WHILE : *]]
[[FOR *index *index *index *step : *call] [TRY : *call]/]
[[FOR *index *index *to *step : *call] [ONE : *call] fail]
[[FOR *index *from *to *step : *call]
	[add *from *step *next] /
	[FOR *index *next *to *step : *call]]
[[IF *condition THEN *then] [res : *condition] / [TRY : *then] /]
[[IF *condition THEN *then] /]
[[IF *condition THEN *then ELSE *else] [res : *condition] / [TRY : *then] /]
[[IF *condition THEN *then ELSE *else] [TRY : *else] /]
[[closure *atom *locals *parameters *term]
	[MAP *locals *local *values]
	[CLOSURE *atom : *values]
	[*atom : *atoms]
	[eq *local *atoms]
	[*atom [*term : *parameters]]]
[[call *atom : *parameters] [*atom *body : *parameters] : *body]
[[BLOCK *declarations : *body]
	[MAP *declarations *local *values]
	[create_atom *closure]
	[CLOSURE *closure : *values]
	[*closure : *atoms]
	[eq *local *atoms]
	[TRY : *body]]
[[ISALL *atom *template : *call]
	[res : *call]
	[*atom *template] fail]
[[ISALL :*]]
[[isall *list *template : *call]
	[create_atom *atom]
	[ACCUMULATOR *atom]
	[ISALL *atom *template : *call]
	[*atom : *list] /]




[[cl *x]/[cl 0 *y *x]]
[[cl *x *y]/[cl 0 *x *y]]
[[cl *x *x [[*a:*b]:*c]][CL *x *a [[*a:*b]:*c]]]
[[cl *x *y [[*a:*b]:*c]][add *x 1 *x2]/[CL *x2 *a *X]
	[cl *x2 *y [[*a:*b]:*c]]]


[[delcl [[*a:*b]:*c]][cl *x [[*a:*b]:*c]][DELCL *x *a]]

[[delallcl *a] [DELCL 0 *a] / [delallcl *a]]
[[delallcl *a]]

[[overwrite [[*a:*b]:*c] [[*a:*h]:*i]][cl *x [[*a:*b]:*c]]
	[OVERWRITE *x [[*a:*h]:*i]]]
[[let *name *selector *value]
	[overwrite [[*name *selector *x]:*r] [[*name *selector *value]]]]


[[exit]]

;[[inner [[*atom : *] : *] []]]
[[inner [* : *] []]]
[[inner *x *y] [pr *y]]
[[inner [*x *y]] [pr *x] [inner *x *y] /]
[[inner [*x *y]] [readln *x] fail]

[[command [exit]]]
[[command [[exit]]]]
[[command *x] [inner [*y *z]] [command *y *z] / [command [*y : *z]]]
[[command *x] [write "Doesn't work"] [nl] / [command *x]]
[[command] [command [command]]]
[[command [[*atom : *t1] : *t2] []] [addcl [[*atom : *t1] :*t2]]]
[[command [[*atom : *t1] : *t2] []] [write "Can not add clause: " [[[*atom : *t1] : *t2]] "\n"] / fail]
[[command [*x : *y] []] / [*x : *y]]
[[command *x *y] [*x : *y]]


[[batch *text][create_atom *atom][file_reader *atom *text]/[batch [batch] *atom]]
[[batch [exit] *reader][*reader]]
[[batch *x *reader][*reader *head]/[batch *x *reader *head]] ;[*reader *tail][*head :*tail] / [batch [*head :*tail] *reader]]
[[batch *x *reader][*reader] / fail]
[[batch *x *reader *head] [is_atom *head] / [*reader *tail] [*head : *tail] / [batch [*head : *tail] *reader]]
[[batch *x *reader *head] / *head [batch *head *reader]]

[[reload] [list :*x] [eq *x [*user *loader :*tail]] [add *loader ".prc" *name] [load *name]]

; demo
[[noteon *key] [keyon 0 *key 100]]
[[noteoff *key] [keyoff 0 *key]]
[[noteoff] [keyoff 0]]
[[computer-do-this : *x] : *x]
[[define-this : *x] [addcl *x]]
[[show] [nl] /]
[[show *text : *show] [is_text *text] [write *text] / [show : *show]]
[[show *x : *show] [pp *x] / [show : *show]]

; main midi messages
[[keyoff *channel *key] [midi_short_msg 128 *channel *key 0]]
[[keyoff *channel *key *velocity] [midi_short_msg 128 *channel *key *velocity]]
[[keyon *channel *key *velocity] [midi_short_msg 144 *channel *key *velocity]]
[[polyaftertouch *channel *key *value] [midi_short_msg 160 *channel *key *value]]
[[control *channel *controller *value] [midi_short_msg 176 *channel *controller *value]]
[[programchange *channel *program] [midi_short_msg 192 *channel *program]]
[[programchange *channel *msb *lsb *program] [add *channel 64 *selector] [sysex *selector 84 *lsb *program *msb]]
[[aftertouch *channel *value] [midi_short_msg 208 *channel *value]]
[[pitch *channel *msb] [midi_short_msg 224 *channel 0 *msb]]
[[pitch *channel *lsb *msb] [midi_short_msg 224 *channel *lsb *msb]]
[[timingclock] [midi_short_msg 248]]
[[START] [midi_short_msg 250]]
[[CONTINUE] [midi_short_msg 251]]
[[STOP] [midi_short_msg 252]]

; controllers
[[keyoff *channel] [midi_short_msg 176 *channel 123 0]]
[[attack *channel *value] [midi_short_msg 176 *channel 73 *value]]
[[release *channel *value] [midi_short_msg 176 *channel 72 *value]]
[[cutoff *channel *value] [midi_short_msg 176 *channel 74 *value]]
[[resonance *channel *value] [midi_short_msg 176 *channel 71 *value]]
[[mono *channel] [midi_short_msg 176 *channel 126 0]]
[[poly *channel] [midi_short_msg 176 *channel 127 0]]
[[bank *channel *msb *lsb] [midi_short_msg 176 *channel 0 *msb] [midi_short_msg 176 *channel 32 *lsb]]
[[bank *channel *value] [midi_short_msg 176 *channel 0 *value]]
[[bank *channel *msb *lsb] [add *channel 64 *selector] [sysex *selector 83 *lsb *msb]]
[[bank *channel *msb] [add *channel 64 *selector] [sysex *selector 82 *msb]]
[[banklsb *channel *value] [midi_short_msg 176 *channel 32 *value]]
[[portaon *channel] [midi_short_msg 176 *channel 65 127]]
[[portaoff *channel] [midi_short_msg 176 *channel 65 0]]
[[portatime *channel *value] [midi_short_msg 176 *channel 5 *value]]
[[volume *channel *value] [midi_short_msg 176 *channel 7 *value]]
[[reverb *channel *value] [midi_short_msg 176 *channel 91 *value]]
[[chorus *channel *value] [midi_short_msg 176 *channel 93 *value]]
[[foot *channel *value] [midi_short_msg 176 *channel 4 *value]]
[[breath *channel *value] [midi_short_msg 176 *channel 2 *value]]
[[pan *channel *value] [midi_short_msg 176 *channel 10 *value]]
[[modulation *channel *value] [midi_short_msg 176 *channel 1 *value]]
[[holdon *channel] [midi_short_msg 176 *channel 64 127]]
[[holdoff *channel] [midi_short_msg 176 *channel 64 0]]
; capital controllers
[[CONTROL *channel *controller *value] [MIDI_SHORT_MSG 176 *channel *controller *value]]
[[ATTACK *channel *value] [MIDI_SHORT_MSG 176 *channel 73 *value]]
[[RELEASE *channel *value] [MIDI_SHORT_MSG 176 *channel 72 *value]]
[[CUTOFF *channel *value] [MIDI_SHORT_MSG 176 *channel 74 *value]]
[[RESONANCE *channel *value] [MIDI_SHORT_MSG 176 *channel 71 *value]]
[[PORTATIME *channel *value] [MIDI_SHORT_MSG 176 *channel 5 *value]]
[[VOLUME *channel *value] [MIDI_SHORT_MSG 176 *channel 7 *value]]
[[REVERB *channel *value] [MIDI_SHORT_MSG 176 *channel 91 *value]]
[[CHORUS *channel *value] [MIDI_SHORT_MSG 176 *channel 93 *value]]
[[FOOT *channel *value] [MIDI_SHORT_MSG 176 *channel 4 *value]]
[[BREATH *channel *value] [MIDI_SHORT_MSG 176 *channel 2 *value]]
[[PAN *channel *value] [MIDI_SHORT_MSG 176 *channel 10 *value]]
[[MODULATION *channel *value] [MIDI_SHORT_MSG 176 *channel 1 *value]]

; nrpn / rpn
[[nrpn *ch *pmsb *plsb *vmsb *vlsb]
	[control *ch 99 *pmsb]
	[control *ch 98 *plsb]
	[control *ch 38 *vlsb]
	[control *ch  6 *vmsb]]
[[nrpn *ch *pmsb *plsb *vmsb]
	[control *ch 99 *pmsb]
	[control *ch 98 *plsb]
	[control *ch  6 *vmsb]]
[[nrpn *ch *pmsb *plsb]
	[control *ch 99 *pmsb]
	[control *ch 98 *plsb]]
[[nrpn *ch *vmsb]
	[control *ch 6 *vmsb]]
[[nrpn *ch]
	[control *ch 99 127]
	[control *ch 98 127]]
[[NRPN *ch *pmsb *plsb *vmsb]
	[control *ch 99 *pmsb]
	[control *ch 98 *plsb]
	[MIDI_SHORT_MSG 176 *ch  6 *vmsb]]
[[NRPN *ch *vmsb]
	[MIDI_SHORT_MSG 176 *ch 6 *vmsb]]



[[rpn *ch *pmsb *plsb *vmsb *vlsb]
	[control *ch 101 *pmsb]
	[control *ch 100 *plsb]
	[control *ch 38 *vlsb]
	[control *ch  6 *vmsb]]
[[rpn *ch *pmsb *plsb *vmsb]
	[control *ch 101 *pmsb]
	[control *ch 100 *plsb]
	[control *ch  6 *vmsb]]
[[rpn *ch *pmsb *plsb]
	[control *ch 101 *pmsb]
	[control *ch 100 *plsb]]
[[rpn *ch *vmsb]
	[control *ch 6 *vmsb]]
[[rpn *ch]
	[control *ch 101 127]
	[control *ch 100 127]]
[[RPN *ch *pmsb *plsb *vmsb]
	[control *ch 101 *pmsb]
	[control *ch 100 *plsb]
	[MIDI_SHORT_MSG 176 *ch  6 *vmsb]]
[[RPN *ch *vmsb]
	[MIDI_SHORT_MSG 176 *ch 6 *vmsb]]

; macros

[[hit *ch *vel]]
[[hit *ch *vel *key :*r]
	[keyon *ch *key *vel]/[hit *ch *vel :*r]]


protect [
	not
	exit command inner
	]
private [inner]


end.
